#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire3000six4xi.py">
#<abstract4xi abstract = "fires to direction six and to distance 3000"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2six4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
       
# -------------------------------------------------------------------------------------------------
# SHOT2SIX - COORDINATE SIGNS OF SHOOT2SIX4XI: (X - ,Y + ,Z - )
# -------------------------------------------------------------------------------------------------    
global shot2six30004xi



# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

shot2six30004xi = {
                1:'-1018x1689y-2259z',
                2:'-1033x2650y-951z',
                3:'-1073x2652y-902z',
                4:'-1093x1615y-2279z',
                5:'-1162x1537y-2298z',
                6:'-1166x2584y-980z',
                7:'-1206x2584y-930z',
                8:'-1226x1457y-2317z',
                9:'-1285x1374y-2336z',
                10:'-1295x2510y-1008z',
                11:'-1335x2509y-959z',
                12:'-1338x1288y-2355z',
                13:'-1386x1201y-2373z',
                14:'-1420x2430y-1036z',
                15:'-1428x1112y-2392z',
                16:'-1460x2427y-987z',
                17:'-1465x1022y-2410z',
                18:'-1495x931y-2427z',
                19:'-149x1180y-2753z',
                20:'-1510x50y-2591z',
                21:'-1521x840y-2445z',
                22:'-1531x131y-2576z',
                23:'-1539x2344y-1064z',
                24:'-1541x748y-2462z',
                25:'-1547x215y-2560z',
                26:'-1555x657y-2479z',
                27:'-1559x300y-2545z',
                28:'-1564x566y-2496z',
                29:'-1566x387y-2529z',
                30:'-1567x476y-2512z',
                31:'-1579x2339y-1016z',
                32:'-1654x2251y-1092z',
                33:'-1693x2245y-1044z',
                34:'-1762x2153y-1120z',
                35:'-1802x2145y-1072z',
                36:'-1865x2049y-1148z',
                37:'-1893x2327y-8z',
                38:'-1904x2040y-1100z',
                39:'-1961x1941y-1175z',
                40:'-2000x1929y-1128z',
                41:'-2012x2224y-38z',
                42:'-2051x1828y-1203z',
                43:'-206x1144y-2765z',
                44:'-2090x1815y-1155z',
                45:'-2125x2116y-68z',
                46:'-2135x1710y-1230z',
                47:'-2173x1696y-1183z',
                48:'-2211x1589y-1258z',
                49:'-2232x2001y-98z',
                50:'-2249x1573y-1211z',
                51:'-2281x1464y-1285z',
                52:'-2318x1446y-1238z',
                53:'-2333x1881y-128z',
                54:'-2343x1336y-1312z',
                55:'-2379x1317y-1265z',
                56:'-2398x1206y-1339z',
                57:'-2427x1755y-158z',
                58:'-2445x1073y-1366z',
                59:'-2485x939y-1392z',
                60:'-2514x1224y-1335z',
                61:'-2514x1625y-188z',
                62:'-2517x803y-1419z',
                63:'-2542x667y-1445z',
                64:'-2559x530y-1471z',
                65:'-2565x121y-1549z',
                66:'-2569x393y-1497z',
                67:'-2571x256y-1523z',
                68:'-2594x1490y-218z',
                69:'-259x1104y-2777z',
                70:'-265x2131y-2094z',
                71:'-2666x1351y-248z',
                72:'-2731x1208y-278z',
                73:'-2788x1063y-308z',
                74:'-2837x914y-337z',
                75:'-2877x764y-367z',
                76:'-2909x611y-397z',
                77:'-2933x458y-427z',
                78:'-2949x303y-456z',
                79:'-2956x148y-486z',
                80:'-309x1063y-2788z',
                81:'-317x2871y-808z',
                82:'-355x1018y-2799z',
                83:'-372x2093y-2115z',
                84:'-397x973y-2809z',
                85:'-412x12y-2971z',
                86:'-436x925y-2820z',
                87:'-440x36y-2967z',
                88:'-465x2842y-837z',
                89:'-467x63y-2962z',
                90:'-470x876y-2830z',
                91:'-476x2050y-2137z',
                92:'-492x93y-2957z',
                93:'-501x826y-2840z',
                94:'-504x2850y-787z',
                95:'-515x126y-2952z',
                96:'-527x775y-2849z',
                97:'-536x161y-2947z',
                98:'-550x724y-2858z',
                99:'-555x199y-2941z',
                100:'-568x672y-2867z',
                101:'-571x239y-2935z',
                102:'-577x2002y-2158z',
                103:'-583x620y-2876z',
                104:'-584x282y-2928z',
                105:'-594x326y-2922z',
                106:'-594x569y-2884z',
                107:'-601x372y-2915z',
                108:'-601x518y-2892z',
                109:'-604x419y-2908z',
                110:'-605x468y-2900z',
                111:'-611x2806y-865z',
                112:'-650x2812y-816z',
                113:'-674x1948y-2178z',
                114:'-755x2762y-894z',
                115:'-767x1890y-2199z',
                116:'-794x2766y-845z',
                117:'-855x1827y-2219z',
                118:'-896x2710y-923z',
                119:'-89x1214y-2741z',
                120:'-935x2713y-873z',
                121:'-939x1760y-2239z'}         


#"
#"/>
    

# -------------------------------------------------------------------------------------------------------------------
#<function4xi function = "fire3000six4xi" usage = "target function for charge2six4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------------------------
def fire3000six4xi(queue2six, consumer_channel2six, publisher_channel2six):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE3000SIX4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE3000SIX4XI -  QUEUE2SIX: ", queue2six)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE3000SIX4XI -  CONSUMER_CHANNEL2SIX: ", consumer_channel2six)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE3000SIX4XI -  PUBLISHER_CHANNEL2SIX: ", publisher_channel2six)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE3000SIX4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2SIX: ", queue2six, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2six.put(shot2six30004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE3000SIX4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2SIX: ", queue2six, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE3000SIX4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2SIX: ", queue2six, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE3000SIX4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2SIX: ", publisher_channel2six, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2six8shot2six3000x4xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2six8shot2six3000x4xi</nack2put4xi>" 
            
        publisher_channel2six.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE3000SIX4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2SIX: ", publisher_channel2six, " - TIME: ", time4xi()) 
            # 
        
    except:
        print(" (STEP 3C/33) OF FIRE3000SIX4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2SIX: ", publisher_channel2six, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE3000SIX4XI - RETURNING QUEUE OBJECT QUEUE2SIX: ", queue2six, " - TIME: ", time4xi())  
        # 
            
    return queue2six    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire3000six4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
